declare type NonJsonTypes = 'date' | 'set' | 'map' | 'regexp' | 'bigint' | 'undefined' | 'infinity' | '-infinity' | 'nan' | 'error';
declare type MetaType = Record<string, NonJsonTypes>;
declare function serialize<T>(data: T): TypedJsonResult;
declare function deserialize<T>({ json, meta }: TypedJsonResult): T | null;
declare function applyMeta<T>(data: T, meta: MetaType): T;
declare type TypedJsonResult = {
    json?: string | null;
    meta?: MetaType;
};
declare type StrigifyParameters = Parameters<typeof JSON.stringify>;
declare function stringify<T>(data: T, replacer?: StrigifyParameters[1], space?: StrigifyParameters[2]): string;
declare function parse<T>(json: string): T | null;
declare const typedjson: {
    serialize: typeof serialize;
    stringify: typeof stringify;
    deserialize: typeof deserialize;
    parse: typeof parse;
    applyMeta: typeof applyMeta;
};
export { serialize, deserialize, stringify, parse, applyMeta };
export type { MetaType, TypedJsonResult };
export default typedjson;
